﻿using System;
using System.Collections.Generic;
using System.Linq;
using Autofac;
using System.Web;
using JetBrains.Annotations;
using Orchard.Caching;
using Orchard.ContentManagement;
using Orchard.Core.Navigation.Services;
using Orchard.UI.Navigation;
using Szmyd.Orchard.Modules.Menu.Services;

namespace Szmyd.Orchard.Modules.Menu {
    public class HierarchicalMenuModule : Module {
        protected override void Load(ContainerBuilder builder) {
            //builder.RegisterType<HierarchicalMainMenuNavigationProvider>().As<INavigationProvider>();
        }

        protected override void AttachToComponentRegistration(Autofac.Core.IComponentRegistry componentRegistry, Autofac.Core.IComponentRegistration registration) {
            if (typeof (MainMenuNavigationProvider).IsAssignableFrom(registration.Activator.LimitType)) {
                registration.Activating += (obj, e) => e.Instance = new EmptyMainMenuNavigationProvider();
            }
        }

        [UsedImplicitly]
        protected class EmptyMainMenuNavigationProvider : INavigationProvider
        {
            public string MenuName { get { return "main"; } }
            public void GetNavigation(NavigationBuilder builder) { }
        }
    }

    
}